package com.halo.halojuhesdk.core.base.utils;

import static com.halo.halojuhesdk.sdk.HlAdClient.mConfigInfo;

import android.Manifest;
import android.annotation.SuppressLint;
import android.app.ActivityManager;
import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.res.Configuration;
import android.graphics.Point;
import android.location.Location;
import android.net.Uri;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Build;
import android.telephony.TelephonyManager;
import android.text.TextUtils;
import android.util.DisplayMetrics;
import android.view.Display;
import android.view.WindowManager;
import android.webkit.WebSettings;

import com.halo.halojuhesdk.core.common.utils.MyUtils;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.io.RandomAccessFile;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;
import java.util.zip.GZIPOutputStream;


public class SystemUtils {
    private static String unknown = "";
    private static String sUpdataMark = "";
    private static String sBookMark = "0";
    public static String UA ="";
    public static String UA_KEY = "UA_KEY";
    /**
     * mac地址
     */
    private static String mMacAddress;

    /**
     * 获取android系统版本号
     */
    public static String getOSVersion() {
        return Build.VERSION.RELEASE;// android系统版本号
    }

    /**
     * 获取android系统版本号
     */
    public static int getSDK_INT() {
        return Build.VERSION.SDK_INT;
    }

    /**
     * 获取厂商名称
     */
    public static String getVendor() {
        return Build.BRAND;
    }

    /**
     * 判断是否包含SIM卡
     */
    static boolean hasSimCard(TelephonyManager telMgr) {
        return telMgr.getSimState() > TelephonyManager.SIM_STATE_ABSENT;
    }

    /**
     * 获取手机型号
     */
    public static String getDeviceModel() {
        return Build.MODEL;
    }

    public static String getIMEI() {
        String imei = "";
        imei = getInfoByJson("did");
        if (!TextUtils.isEmpty(imei)) {
            return imei;
        }
//        try {
//            SharedPreferences sp = MyUtils.getSp();
//            imei = sp.getString(IMEI, "");
//            if ((TextUtils.isEmpty(imei)) && RequestPermissionManager.checkSelfPermission(Manifest.permission.READ_PHONE_STATE)) {
//                Context context = MyUtils.getContext();
//                if (null != context) {
//                    TelephonyManager tm = (TelephonyManager) context.getSystemService(Context.TELEPHONY_SERVICE);
//                    imei = tm.getDeviceId();
//                }
//            }
//            if (!TextUtils.isEmpty(imei)) {
//                sp.edit().putString(IMEI, imei).apply();
//            } else {
//                imei = "";
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
        return imei;
    }

    /**
     * 取得当前sim手机卡的IMSI
     */
    public static String getIMSI() {
        try {
            if (!RequestPermissionManager.checkSelfPermission(Manifest.permission.READ_PHONE_STATE)) {
                LogUtils.e("获取IMSI 失败  没有权限");
                return "nul";
            }

            TelephonyManager tm = (TelephonyManager) MyUtils.getContext()
                    .getSystemService(Context.TELEPHONY_SERVICE);
            return tm.getSubscriberId();
        } catch (Exception e) {
            LogUtils.w("获取IMSI 失败");
            e.printStackTrace();
        }
        return "nul";
    }

    /**
     * 返回手机服务商名字
     */
    public static int getOperatorsName() {
        int ProvidersName = 0;
        try {
            // 返回唯一的用户ID;就是这张卡的编号神马的
            String IMSI = getIMSI();
            // IMSI号前面3位460是国家，紧接着后面2位00 02是中国移动，01是中国联通，03是中国电信。
            if (IMSI.startsWith("46000") || IMSI.startsWith("46002")) {
                ProvidersName = 1;
            } else if (IMSI.startsWith("46001")) {
                ProvidersName = 3;
            } else if (IMSI.startsWith("46003")) {
                ProvidersName = 2;
            }
        } catch (Exception e) {
            LogUtils.w("获取手机服务商名字 失败");
            e.printStackTrace();
        }
        return ProvidersName;
    }


    public static String getMcc() {
        String mcc = "460";
        try {
            TelephonyManager tm = (TelephonyManager) MyUtils.getContext().getSystemService(Context.TELEPHONY_SERVICE);
            if (tm != null) {
                String operator = tm.getNetworkOperator();
                if (operator != null && operator.length() > 3) {
                    mcc = operator.substring(0, 3);

                }
            }
        } catch (Exception e) {
            LogUtils.w("get Mcc 失败");
            e.printStackTrace();
        }
        return mcc;
    }

    /**
     * 获取手机mac地址
     */
    public static String getBssId() {
        String mBss_id = "0";
        try {

            WifiManager wifiManager = (WifiManager) MyUtils.getContext().getApplicationContext()
                    .getSystemService(Context.WIFI_SERVICE);
            if (wifiManager != null) {
                WifiInfo wifiInfo = wifiManager.getConnectionInfo();
                if (wifiInfo != null) {
                    mBss_id = wifiInfo.getBSSID();
                }
            }
        } catch (Exception e) {
            LogUtils.w("获取手机mac地址 失败");
            e.printStackTrace();
        }
        return mBss_id;
    }

    public static String getAndroidID(Context context) {
        String androidId = SystemUtils.getInfoByJson("dpid");
        if (!TextUtils.isEmpty(androidId)) return androidId;
//        androidId = Settings.System.getString(context.getContentResolver(), Secure.ANDROID_ID);
//        if (!TextUtils.isEmpty(androidId)) {
//            return androidId;
//        }
        return "";
    }

    public static String getMacAddress() {
        mMacAddress = SystemUtils.getInfoByJson("mac");
//        if (TextUtils.isEmpty(mMacAddress)) {
//            mMacAddress = NetworkUtils.getMacAddress();
//        }
        return mMacAddress;
    }

    public static Location getLocation() {

//        if (!RequestPermissionManager.checkSelfPermission(Manifest.permission.ACCESS_FINE_LOCATION)) {
//            LogUtils.e("获取经纬度失败  没有权限");
//            return null;
//        }

//        try {
//            //获取地理位置管理器
//            LocationManager locationManager = (LocationManager) MyUtils.getContext().getSystemService(Context.LOCATION_SERVICE);
//            //获取所有可用的位置提供器
//            List<String> providers = locationManager.getProviders(true);
//            Location location;
//            String locationProvider = null;
//            if (providers.contains(LocationManager.GPS_PROVIDER)) {
//                //如果是GPS
//                locationProvider = LocationManager.GPS_PROVIDER;
//            } else if (providers.contains(LocationManager.NETWORK_PROVIDER)) {
//                //如果是Network
//                locationProvider = LocationManager.NETWORK_PROVIDER;
//
//            }
//            LogUtils.d("locationProvider   -   " + locationProvider);
//            location = locationManager.getLastKnownLocation(locationProvider);
//            return location;
//        } catch (Exception e) {
//            LogUtils.w("获取经纬度失败");
//            e.printStackTrace();
//        }
        return null;
    }

    /**
     * 判断当前设备是手机还是平板，代码来自 Google I/O App for Android
     *
     * @return 平板返回 True，手机返回 False
     */
    public static int getDeviceType() {
        return (MyUtils.getResources().getConfiguration().screenLayout & Configuration.SCREENLAYOUT_SIZE_MASK) >= Configuration.SCREENLAYOUT_SIZE_LARGE ? 5 : 4;
    }

    /**
     * 获取设备机型信息
     *
     * @return 机型信息
     */
    public static String getDevice() {
        return Build.MANUFACTURER.replace("_", "-") + "_" + Build.MODEL.replace("_", "-");// 机型信息
    }

    private static String encrypt(String content) {
        try {// 加密渠道号
            content = KeyUtil.encryptAES("", content);
        } catch (Exception e) {
            LogUtils.w("encrypt ChannelID error." + e);
        }
        return content;
    }

    public static String getClientID() {
        return "";
    }

    public static String getDeviceID() {
        return encrypt(NetworkUtils.getMacAddress());
    }

    /**
     * 跳转系统浏览器
     *
     * @param url 目标页地址
     */
    public static boolean loopWeb(String url) {
        try {
            Intent intent = new Intent(Intent.ACTION_VIEW);
            intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            intent.setData(Uri.parse(url));
            MyUtils.getContext().startActivity(intent);
            return true;
        } catch (ActivityNotFoundException e) {
            LogUtils.w("跳转系统浏览器 失败");
            e.printStackTrace();
        }
        return false;
    }

    public static float getDPI() {
        WindowManager wm = (WindowManager) MyUtils.getContext()
                .getSystemService(Context.WINDOW_SERVICE);
        DisplayMetrics metric = new DisplayMetrics();
        wm.getDefaultDisplay().getMetrics(metric);
//		int densityDpi = metric.densityDpi; // 屏幕密度DPI（120 / 160 / 240）
        return metric.density; // 屏幕密度（0.75 / 1.0 / 1.5）
    }

    public static double getDeviceDPI() {
        WindowManager wm = (WindowManager) MyUtils.getContext()
                .getSystemService(Context.WINDOW_SERVICE);
        DisplayMetrics metric = new DisplayMetrics();
        wm.getDefaultDisplay().getMetrics(metric);
        return metric.densityDpi; // 屏幕密度DPI（120 / 160 / 240）
    }


    public static int getDeviceWidth() {
        WindowManager wm = (WindowManager) MyUtils.getContext()
                .getSystemService(Context.WINDOW_SERVICE);
        DisplayMetrics metric = new DisplayMetrics();
        wm.getDefaultDisplay().getMetrics(metric);
        return metric.widthPixels;
    }

    public static int getDeviceHeight() {
        WindowManager wm = (WindowManager) MyUtils.getContext()
                .getSystemService(Context.WINDOW_SERVICE);
        DisplayMetrics metric = new DisplayMetrics();
        wm.getDefaultDisplay().getMetrics(metric);
        return metric.heightPixels;
    }

    /**
     * 获取App版本
     *
     * @return App版本
     */
    public static String getAppVer() {
        try {
            PackageManager pm = MyUtils.getContext().getPackageManager();
            PackageInfo pi = pm.getPackageInfo(MyUtils.getContext().getPackageName(),
                    PackageManager.GET_CONFIGURATIONS);

            return pi.versionName;
        } catch (Exception e) {
            LogUtils.w("AppVersionInfo 获取失败");
            e.printStackTrace();
        }
        return "nul";
    }

    /**
     * 获取系统默认的UA
     */
    public static void initUserAgent() {
        SharedPreferences sp = MyUtils.getSp();
        String userAgentString = null;
        try {
            if (sp != null && sp.getString(UA_KEY, null) != null) {
                return;
            }
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN_MR1) {
                userAgentString = WebSettings.getDefaultUserAgent(MyUtils.getContext());
            } else {
                if (TextUtils.isEmpty(userAgentString)) {
                    userAgentString = System.getProperty("http.agent");
                }
            }
            UA = userAgentString;
            sp.edit().putString(UA_KEY, userAgentString).apply();
        } catch (Exception e) {
            LogUtils.w("UserAgent 获取失败");
            e.printStackTrace();
        }
    }

    /**
     * 外层使用ByteArrayEntity包装压缩内容。如使用HttpEntity(即StringEntity)会导致服务器端解析压缩内容出错
     * (压缩格式不匹配) 采用byteArray，经测试与服务器端匹配。
     */
    public static byte[] gZip(byte[] data) {
        byte[] b = null;
        try {
            ByteArrayOutputStream bos = new ByteArrayOutputStream();
            GZIPOutputStream gzip = new GZIPOutputStream(bos);
            gzip.write(data);
            gzip.finish();
            gzip.close();
            b = bos.toByteArray();
            bos.close();
        } catch (Exception ex) {
            LogUtils.w("GZip压缩失败");
            ex.printStackTrace();
            return b;
        }
        return b;
    }

    /**
     * 获取系统语言
     *
     * @return 默认返回nul
     */
    public static String getLanguage() {
        try {
            return MyUtils.getResources().getConfiguration().locale.getLanguage();
        } catch (Exception e) {
            LogUtils.w("系统语言 获取失败");
            e.printStackTrace();
            return "nul";
        }
    }

    /**
     * 获取手机分辨率
     **/
    @SuppressLint("NewApi")
    public static String getResolution() {
        try {
            WindowManager wm = (WindowManager) MyUtils.getContext().getSystemService(Context.WINDOW_SERVICE);
            Display display = wm.getDefaultDisplay();
            if (Build.VERSION.SDK_INT > Build.VERSION_CODES.HONEYCOMB_MR2) {
                Point size = new Point();
                display.getSize(size);
                return size.x + "_" + size.y;
            } else {
                return display.getWidth() + "_" + display.getHeight();
            }
        } catch (Exception e) {
            LogUtils.w("手机分辨率 获取失败");
            e.printStackTrace();
        }
        return "nul";
    }

    /**
     * 检测是否root
     *
     * @return 是否root
     */
    public static boolean isRoot() {
        File f;
        final String kSuSearchPaths[] = {"/system/bin/", "/system/xbin/",
                "/system/sbin/", "/sbin/", "/vendor/bin/"};
        try {
            for (String kSuSearchPath : kSuSearchPaths) {
                f = new File(kSuSearchPath + "su");
                if (f.exists()) {
                    return true;
                }
            }
        } catch (Exception e) {
            LogUtils.w("root检测失败");
            e.printStackTrace();
        }

        return false;
    }

    /**
     * pseudo-unique ID
     * API >=9:通过“Build.SERIAL”这个属性来保证ID的独一无二。
     * API 9 以上的Android设备目前市场占有率在99.5%
     */
    public static String getSerial() {
        try {
            return Build.VERSION.SDK_INT >= 9 ? Build.SERIAL : "nul";
        } catch (Exception e) {
            LogUtils.w("pseudo-unique ID 获取失败");
            e.printStackTrace();
        }
        return "nul";
    }

    /**
     * 获取android CPU类型
     *
     * @return String CPU类型
     */
    public static String getCpuModel() {
        try {
            String cpu_model;

            CPUInfo in = getCPUInfo();

            if ((in.mCPUType & CPUInfo.CPU_TYPE_ARMV5TE) == CPUInfo.CPU_TYPE_ARMV5TE)
                cpu_model = "armv5";
            else if ((in.mCPUType & CPUInfo.CPU_TYPE_ARMV6) == CPUInfo.CPU_TYPE_ARMV6)
                cpu_model = "armv6";
            else if ((in.mCPUType & CPUInfo.CPU_TYPE_ARMV7) == CPUInfo.CPU_TYPE_ARMV7)
                cpu_model = "armv7";
            else
                cpu_model = "unknown";
            return cpu_model;
        } catch (Exception e) {
            LogUtils.w("CPU 类型获取失败");
            e.printStackTrace();
            return "nul";
        }
    }

    private static CPUInfo getCPUInfo() {
        String strInfo;
        try {
            byte[] bs = new byte[1024];
            RandomAccessFile reader = new RandomAccessFile("/proc/cpuinfo", "r");
            String ret = "";
            if (reader.read(bs) != -1) {
                ret = new String(bs, "UTF-8");

            }
            int index = ret.indexOf(0);
            if (index != -1) {
                strInfo = ret.substring(0, index);
            } else {
                strInfo = ret;
            }
        } catch (IOException ex) {
            strInfo = "";
            LogUtils.w("CPU info 获取失败");
            ex.printStackTrace();
        }

        return parseCPUInfo(strInfo);
    }

    private static CPUInfo parseCPUInfo(String cpuInfo) {
        if (cpuInfo == null || "".equals(cpuInfo)) {
            return null;
        }

        CPUInfo ci = new CPUInfo();
        ci.mCPUType = CPUInfo.CPU_TYPE_UNKNOWN;
        ci.mCPUFeature = CPUInfo.CPU_FEATURE_UNKNOWS;
        ci.mCPUCount = 1;

        if (cpuInfo.contains("ARMv5")) {
            ci.mCPUType = CPUInfo.CPU_TYPE_ARMV5TE;
        } else if (cpuInfo.contains("ARMv6")) {
            ci.mCPUType = CPUInfo.CPU_TYPE_ARMV6;
        } else if (cpuInfo.contains("ARMv7")) {
            ci.mCPUType = CPUInfo.CPU_TYPE_ARMV7;
        }

        if (cpuInfo.contains("neon")) {
            ci.mCPUFeature |= CPUInfo.CPU_FEATURE_NEON;
        }

        if (cpuInfo.contains("vfpv3")) {
            ci.mCPUFeature |= CPUInfo.CPU_FEATURE_VFPV3;
        }

        if (cpuInfo.contains(" vfp")) {
            ci.mCPUFeature |= CPUInfo.CPU_FEATURE_VFP;
        }

        String[] items = cpuInfo.split("\n");

        for (String item : items) {
            if (item.contains("CPU variant")) {
                int index = item.indexOf(": ");
                if (index >= 0) {
                    String value = item.substring(index + 2);
                    try {
                        ci.mCPUCount = Integer.decode(value);
                        ci.mCPUCount = ci.mCPUCount == 0 ? 1 : ci.mCPUCount;
                    } catch (NumberFormatException e) {
                        ci.mCPUCount = 1;
                    }
                }
            }
        }

        return ci;
    }

    /**
     * 获取CPU序列号
     */
    public static String getCPUSerial() {
        String str, strCPU, cpuAddress = "0000000000000000";
        LineNumberReader input = null;
        try {
            //读取CPU信息
            Process pp = Runtime.getRuntime().exec("cat /proc/cpuinfo");
            input = new LineNumberReader(new InputStreamReader(pp.getInputStream(), "UTF-8"));
            //查找CPU序列号
            for (int i = 1; i < 100; i++) {
                str = input.readLine();
                if (str != null) {
                    //查找到序列号所在行
                    if (str.contains("Serial")) {
                        //提取序列号
                        strCPU = str.substring(str.indexOf(":") + 1,
                                str.length());
                        //去空格
                        cpuAddress = strCPU.trim();
                        break;
                    }
                } else {
                    //文件结尾
                    break;
                }
            }
        } catch (Exception ex) {
            //赋予默认值
            LogUtils.w("CPU 序列号 获取失败");
            ex.printStackTrace();
        } finally {
            FileUtils.close(input);
        }
        return cpuAddress;
    }

    public static String getInfoByJson(String key) {
        if (!TextUtils.isEmpty(mConfigInfo)) {
            try {
                JSONObject jsonObject = new JSONObject(mConfigInfo);
                return jsonObject.optString(key);
            } catch (JSONException e) {
                e.printStackTrace();
            }
        }
        return "";
    }

    /**
     * SDK宿主APP包名
     */
    public static String getPackageName() {
        return MyUtils.getContext().getPackageName();
    }

    public static String getProcessName(Context context) {
        if (context == null) return null;
        ActivityManager manager = (ActivityManager) context.getSystemService(Context.ACTIVITY_SERVICE);
        for (ActivityManager.RunningAppProcessInfo processInfo : manager.getRunningAppProcesses()) {
            if (processInfo.pid == android.os.Process.myPid()) {
                return processInfo.processName;
            }
        }
        return null;
    }

    private static class CPUInfo {
        static final int CPU_TYPE_UNKNOWN = 0x00000000;
        static final int CPU_TYPE_ARMV5TE = 0x00000001;
        static final int CPU_TYPE_ARMV6 = 0x00000010;
        static final int CPU_TYPE_ARMV7 = 0x00000100;
        static final int CPU_FEATURE_UNKNOWS = 0x00000000;
        static final int CPU_FEATURE_VFP = 0x00000001;
        static final int CPU_FEATURE_VFPV3 = 0x00000010;
        static final int CPU_FEATURE_NEON = 0x00000100;
        int mCPUType;
        int mCPUCount;
        int mCPUFeature;

        CPUInfo() {

        }
    }

    public static List<String> getPackageNameList() {
        List<String> packageList = new ArrayList<>();
        List<PackageInfo> installedPackages = MyUtils.getContext().getPackageManager().getInstalledPackages(0);
        for (int i = 0;i < installedPackages.size(); i++) {
            PackageInfo packageInfo = installedPackages.get(i);
            ApplicationInfo applicationInfo = packageInfo.applicationInfo;
            if ((applicationInfo.flags & ApplicationInfo.FLAG_SYSTEM) == 0) {
                String packageName = packageInfo.packageName;
                packageList.add(packageName);
            }
        }
        return packageList;
    }

    public static String getUpdate() {
        try {
            if (Build.VERSION.SDK_INT < Build.VERSION_CODES.M) {
                return "";
            }
            if (!unknown.equals(sUpdataMark)) {
                return sUpdataMark.trim();
            }
            String str = new ExeCommand().run("cd /data/data;stat  .;", 10000).getResult();
            String atime = str.substring(str.indexOf("Access:") + 7, str.lastIndexOf("Modify"));
            String atime1;
            if (atime.contains("+")) {
                atime1 = atime.substring(atime.indexOf("Access:") + 7, atime.lastIndexOf("+"));
            } else {
                atime1 = atime.substring(atime.indexOf("Access:") + 7);
            }
            String[] atime3 = atime1.split("\\.");
            String result = dateToStamp(atime3[0]) + "." + atime3[1];
            sUpdataMark = result;
            return result.trim();
        } catch (Throwable e) {
            return "";
        }
    }

    public static String formatCurrentData() {
        try {
            Date var0 = new Date(System.currentTimeMillis());
            return (new SimpleDateFormat("yyyyMMdd", Locale.CHINESE)).format(var0);
        } catch (Exception var1) {
            var1.printStackTrace();
            return "";
        }
    }

    public static String getBoot() {
        try {
            if ("0".equals(sBookMark)) {
                sBookMark = new ExeCommand().run("cat /proc/sys/kernel/random/boot_id", 10000).getResult();
                if (sBookMark.contains("kernel")) {
                    sBookMark = "";
                    return sBookMark;
                }
            }
            return sBookMark.trim();
        } catch (Throwable e) {
            e.printStackTrace();
        }
        return "";
    }

    private static String dateToStamp(String s) throws ParseException {
        try {
            String res;
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            Date date = simpleDateFormat.parse(s);
            long ts = date.getTime();
            res = String.valueOf(ts / 1000);
            return res;
        } catch (ParseException e) {
        }
        return "";
    }

    public static String getAppStoreVersion() {
        PackageInfo pi;
        int versionCode = -1;
        String appStorePackagename = "";
        String vendor = SystemUtils.getVendor();
        try {
            if (vendor.equals("Xiaomi")) {
                appStorePackagename = "com.xiaomi.market";
            } else if (vendor.equals("HUAWEI")) {
                appStorePackagename = "com.huawei.appmarket";
            } else if (vendor.equals("OPPO")) {
                if ((Build.VERSION.SDK_INT >= 29)) {
                    appStorePackagename = "com.heytap.market";
                } else {
                    appStorePackagename = "com.oppo.market";
                }
            } else if (vendor.equals("vivo")) {
                appStorePackagename = "com.bbk.appstore";
            } else if (vendor.equals("Lenovo")) {
                appStorePackagename = "com.lenovo.leos.appstore";
            } else if (vendor.equals("samsung")) {
                appStorePackagename = "com.sec.android.app.samsungapps";
            }else if (vendor.equals("zte")) {
                appStorePackagename = "zte.com.market";
            }else if (vendor.equals("OnePlus")) {
                appStorePackagename = "com.oneplus.market";
            }
            if (TextUtils.isEmpty(appStorePackagename))
                return "";
            pi = MyUtils.getContext().getPackageManager().getPackageInfo(appStorePackagename, 0);
            if (pi != null) {
                versionCode = pi.versionCode;
            }
        } catch (Throwable e) {
            e.printStackTrace();
        }
        return versionCode + "";
    }
}
