package com.halo.halojuhesdk.core.request;

import android.text.TextUtils;

import java.util.UUID;

public class HlStatisManager {
    private static HlStatisManager mHlStatisManager;
    public static final String STEPNAME_NOQUOTA = "noquota";
    public static final String STEPNAME_QUOTA = "quota";
    public static final String STEPNAME_REPORT = "report";
    public static final String STEPNAME_REPORT_CLICK = "click";
    public static final String STEPNAME_REPORT_IMP = "imp";
    public static final String STEPNAME_REPORT_CLOSE = "ad_close";
    public static final String STEPNAME_ERROR = "error";
    public static final String STEPNAME_REPORT_VIDEO_START = "video_start";
    public static final String STEPNAME_REPORT_VIDEO_END = "video_complete";

    private String mBannerReqId = "";
    private String mInsertReqId = "";
    private String mSplashReqId = "";
    private String mNativeReqId = "";
    private String mVideoReqId = "";
    private String mConfigReqId = "";

    public static HlStatisManager getInstance() {

        if (mHlStatisManager == null) {
            synchronized (HlStatisManager.class) {
                if (mHlStatisManager == null) {
                    mHlStatisManager = new HlStatisManager();
                }
            }
        }
        return mHlStatisManager;
    }

    private HlStatisManager() {

    }

    /**
     * @param bean     广告信息
     * @param stepName 上报类型
     * @param action   展示、点击action
     */
    public void reportStatic(SlotBean bean, String stepName, String action, String reqId) {
        if (bean != null) {
            StatisProcessor processor = new StatisProcessor(bean, stepName, action, reqId, "");
            processor.process();
        }
    }

    public void reportStaticCallBack(SlotBean bean, String stepName, String action, String reqId, final UpRequestCallBack callBack) {
        if (bean != null) {
            StatisProcessor processor = new StatisProcessor(bean, stepName, action, reqId, "");
            processor.process();
            processor.callBack(new RequestCallBack() {
                @Override
                public void onSuccess() {
                    if (callBack != null) {
                        callBack.onSuccess();
                    }
                }

                @Override
                public void onError() {
                    if (callBack != null) {
                        callBack.onError();
                    }
                }
            });
        }
    }

    public void reportStaticError(SlotBean bean, String stepName, String action, String reqId, String errorMsg) {
        if (bean != null) {
            StatisProcessor processor = new StatisProcessor(bean, stepName, action, reqId, errorMsg);
            processor.process();
        }
    }

    public void reportStat(String postJson, String reqId) {
        if (!TextUtils.isEmpty(postJson)) {
            StatProcessor processor = new StatProcessor(postJson, reqId);
            processor.process();
        }
    }

    public void cBannerRequestid() {
        mBannerReqId = UUID.randomUUID().toString();
    }

//    public String getBannerReqId() {
//        return mBannerReqId;
//    }

    public void cInsertRequestid() {
        mInsertReqId = UUID.randomUUID().toString();
    }

//    public String getInsertReqId() {
//        return mInsertReqId;
//    }

    public void cSplashRequestid() {
        mSplashReqId = UUID.randomUUID().toString();
    }

//    public String getSplashReqId() {
//        return mSplashReqId;
//    }

    public void cNativeRequestid() {
        mNativeReqId = UUID.randomUUID().toString();
    }

//    public String getNativeReqId() {
//        return mNativeReqId;
//    }

    public void cVideoRequestid() {
        mVideoReqId = UUID.randomUUID().toString();
    }

//    public String getVideoReqId() {
//        return mVideoReqId;
//    }

    public void cConfigRequestid() {
        mConfigReqId = UUID.randomUUID().toString();
    }
    public String getConfigReqId() {
        return mConfigReqId;
    }
}
