package com.halo.halojuhesdk.sdk.listener;

import android.view.View;

import androidx.annotation.IdRes;
import androidx.annotation.LayoutRes;

import com.applovin.mediation.nativeAds.MaxNativeAdViewBinder;

public class HlNativeAdViewBinder {
    protected final View mainView;
    @LayoutRes
    protected final int layoutResourceId;
    @IdRes
    protected final int titleTextViewId;
    @IdRes
    protected final int advertiserTextViewId;
    @IdRes
    protected final int bodyTextViewId;
    @IdRes
    protected final int iconImageViewId;
    @IdRes
    protected final int iconContentViewId;
    @IdRes
    protected final int starRatingContentViewGroupId;
    @IdRes
    protected final int optionsContentViewGroupId;
    @IdRes
    protected final int optionsContentFrameLayoutId;
    @IdRes
    protected final int mediaContentViewGroupId;
    @IdRes
    protected final int mediaContentFrameLayoutId;
    @IdRes
    protected final int callToActionButtonId;
    protected final String templateType;

    private HlNativeAdViewBinder(View var1, @LayoutRes int var2, @IdRes int var3, @IdRes int var4, @IdRes int var5, @IdRes int var6, @IdRes int var7, @IdRes int var8, @IdRes int var9, @IdRes int var10, @IdRes int var11, @IdRes int var12, @IdRes int var13, String var14) {
        this.mainView = var1;
        this.layoutResourceId = var2;
        this.titleTextViewId = var3;
        this.advertiserTextViewId = var4;
        this.bodyTextViewId = var5;
        this.iconImageViewId = var6;
        this.iconContentViewId = var7;
        this.starRatingContentViewGroupId = var8;
        this.optionsContentViewGroupId = var9;
        this.optionsContentFrameLayoutId = var10;
        this.mediaContentViewGroupId = var11;
        this.mediaContentFrameLayoutId = var12;
        this.callToActionButtonId = var13;
        this.templateType = var14;
    }

    public static class Builder {
        private final View mainView;
        @LayoutRes
        private final int layoutResourceId;
        @IdRes
        private int titleTextViewId;
        @IdRes
        private int advertiserTextViewId;
        @IdRes
        private int bodyTextViewId;
        @IdRes
        private int iconImageViewId;
        @IdRes
        private int iconContentViewId;
        @IdRes
        private int optionsContentViewGroupId;
        @IdRes
        private int optionsContentFrameLayoutId;
        @IdRes
        private int starRatingContentViewGroupId;
        @IdRes
        private int mediaContentViewGroupId;
        @IdRes
        private int mediaContentFrameLayoutId;
        @IdRes
        private int callToActionButtonId;
        private String templateType;

        public Builder(View var1) {
            this(-1, var1);
        }

        public Builder(@LayoutRes int var1) {
            this(var1, (View)null);
        }

        private Builder(@LayoutRes int var1, View var2) {
            this.titleTextViewId = -1;
            this.advertiserTextViewId = -1;
            this.bodyTextViewId = -1;
            this.iconImageViewId = -1;
            this.iconContentViewId = -1;
            this.optionsContentViewGroupId = -1;
            this.optionsContentFrameLayoutId = -1;
            this.starRatingContentViewGroupId = -1;
            this.mediaContentViewGroupId = -1;
            this.mediaContentFrameLayoutId = -1;
            this.callToActionButtonId = -1;
            this.layoutResourceId = var1;
            this.mainView = var2;
        }

        public HlNativeAdViewBinder.Builder setTitleTextViewId(@IdRes int var1) {
            this.titleTextViewId = var1;
            return this;
        }

        public HlNativeAdViewBinder.Builder setAdvertiserTextViewId(@IdRes int var1) {
            this.advertiserTextViewId = var1;
            return this;
        }

        public HlNativeAdViewBinder.Builder setBodyTextViewId(@IdRes int var1) {
            this.bodyTextViewId = var1;
            return this;
        }

        public HlNativeAdViewBinder.Builder setIconImageViewId(@IdRes int var1) {
            this.iconImageViewId = var1;
            return this;
        }

        @Deprecated
        protected HlNativeAdViewBinder.Builder setIconContentViewId(@IdRes int var1) {
            this.iconContentViewId = var1;
            return this;
        }

        public HlNativeAdViewBinder.Builder setOptionsContentViewGroupId(@IdRes int var1) {
            this.optionsContentViewGroupId = var1;
            return this;
        }

        @Deprecated
        protected HlNativeAdViewBinder.Builder setOptionsContentFrameLayoutId(@IdRes int var1) {
            this.optionsContentFrameLayoutId = var1;
            return this;
        }

        public HlNativeAdViewBinder.Builder setStarRatingContentViewGroupId(@IdRes int var1) {
            this.starRatingContentViewGroupId = var1;
            return this;
        }

        public HlNativeAdViewBinder.Builder setMediaContentViewGroupId(@IdRes int var1) {
            this.mediaContentViewGroupId = var1;
            return this;
        }

        @Deprecated
        protected HlNativeAdViewBinder.Builder setMediaContentFrameLayoutId(@IdRes int var1) {
            this.mediaContentFrameLayoutId = var1;
            return this;
        }

        public HlNativeAdViewBinder.Builder setCallToActionButtonId(@IdRes int var1) {
            this.callToActionButtonId = var1;
            return this;
        }

        protected HlNativeAdViewBinder.Builder setTemplateType(String var1) {
            this.templateType = var1;
            return this;
        }

        public HlNativeAdViewBinder build() {
            return new HlNativeAdViewBinder(this.mainView, this.layoutResourceId, this.titleTextViewId, this.advertiserTextViewId, this.bodyTextViewId, this.iconImageViewId, this.iconContentViewId, this.starRatingContentViewGroupId, this.optionsContentViewGroupId, this.optionsContentFrameLayoutId, this.mediaContentViewGroupId, this.mediaContentFrameLayoutId, this.callToActionButtonId, this.templateType);
        }
    }
}
